<template>
  <header>Reaction Timer</header>
  <div>
    <button class="button" :disabled="this.runningGame" @click="startGame">Play</button>
  </div>
  <Block v-if="isPlaying" :delay="delay" @close="finishGame"> </Block>
  <Results v-if="showResult" :message="this.sentMessage" @click="toggleResult"> </Results>
</template>


<script>
import Block from './components/Block.vue';
import Results from './components/Results.vue'

export default {

  components: {
    Block, 
    Results
  },

  data() {
    return {
      runningGame: false,
      delay: false,
      isPlaying: false,
      reactionTime: 0,
      showResult: false,
      sentMessage: "",
    }
  },

  methods: {
    startGame() {
      this.delay = (2 + Math.random() * 5) * 1000;
      this.isPlaying = true;
      this.runningGame = !this.runningGame;
      this.showResult = false;
    },

    finishGame(reactionTime) {
      this.runningGame = !this.runningGame;
      this.isPlaying = false;
      this.reactionTime = (reactionTime/1000).toFixed(3);
      this.sentMessage = 'Your result is: ' + this.reactionTime + ' seconds'
      this.toggleResult()
    },

    toggleResult() {
      this.showResult = !this.showResult
    }    
  }

}
</script>


<style scoped>
header {
  font-size: 4rem;
  color: rgb(1, 153, 115);
  font-family: Arial;
  text-align: center;
}

.button {
  margin: 2rem auto;
  display: block;
  background-color: rgb(1, 153, 115);
  color: rgb(255, 255, 255);
  font-size: 3rem;
  place-items: center;
  border-radius: 10px;
}

.button:disabled {
  margin: 2rem auto;
  display: block;
  background-color: rgb(206, 209, 209);
  color: rgb(112, 112, 112);
  font-size: 3rem;
  place-items: center;
  border-radius: 10px;
}
</style>
